Subject: Re: bug#14233: 24.3; Don't constrain frame size to character multiples

From: Eli Zaretskii <[email-masked]>
Date: Sat, 20 Apr 2013 16:13:49 +0300

> Date: Sat, 20 Apr 2013 14:56:47 +0200
> From: Jan Djärv <[email-masked]>
> CC: Eli Zaretskii <[email-masked]>, [email-masked], 
>  [email-masked]
> 
> I don't understand why we want to resize in pixels instead of
> characters.

See the beginning of this bug report, and the TODO item.

In a nutshell, we resize in units of canonical character size that
mean nothing to the windowing system and the rest of the machine.  The
downside of that is that some specifications of the dimensions produce
surprising results, and for no good reason.

> But if you insist on resizing with pixels instead of characters, you have turn 
> WM hints off for NS and X.

Could you describe in short the role of those hints for Emacs display?
I don't believe we have this documented anywhere.

> You should thoroughly test this change on X with a couple of
> different window manager before checking it in.  Resizing is a bit
> of a mess on X because the intreactions with the window manager, and
> the strange ways Emacs deals with GUI elements.

Those "strange ways" are partly explained by the restrictions Martin
is trying to lift, AFAIK.

> But I'd prefer if the text part is resizable only in terms of lines/columns. 

Why?  Is there any other reason beyond WM hints?

> An exception to this is tiling window managers and fullscreen behaviour.

If we cannot resize in pixels, we cannot make those exceptions, can
we?